"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("fs-extra-debug");
const path = require("path");
const semver = require("semver");
function checkNodeVersion() {
    try {
        const root = path.join((module.parent && module.parent.filename) || __filename, '../..');
        const pjson = require(path.join(root, 'package.json'));
        const nodeVersion = process.versions.node;
        const engine = pjson.engines && pjson.engines.node;
        if (!engine)
            return;
        if (!semver.satisfies(nodeVersion, engine)) {
            process.stderr.write(`WARNING\nWARNING Node version must be ${pjson.engines.node} to use ${pjson.name}\nWARNING\n`);
        }
    }
    catch (_a) { }
}
checkNodeVersion();
const command_1 = require("./command");
const engine_1 = require("./engine");
exports.Engine = engine_1.default;
function run(argv = process.argv.slice(2), opts = {}) {
    return command_1.default.run(argv, Object.assign({ root: module.parent.filename }, opts));
}
exports.run = run;
exports.default = run;
